version 8.2
clear
set matsize 180
set logtype text
set more off
adopath + "brazdspl/%stata/ado"

cd "$root"

capture log close
log using "brazrloc/logs/pia-niv50.log", replace

// Additional years
tempfile addyrs
input year
1986
1987
1988
1989
1999
2000
2001
end
save `addyrs'

// PIA at Nivel 50
//-----------------

use firm year niv50 using "brazaux/pia/random-3firm-firmlist-rndmnr.dta", clear
duplicates drop
rename firm cnpj_radic
qui do "rais/cnae/niv50.do"
label values niv50 niv50
append using `addyrs'
fillin cnpj_radic year
sort cnpj_radic year
replace niv50=niv50[_n-1] if niv50==. & cnpj_radic==cnpj_radic[_n-1]
gsort cnpj_radic -year
replace niv50=niv50[_n-1] if niv50==. & cnpj_radic==cnpj_radic[_n-1]
sort cnpj_radic year
drop if cnpj_radic==.
drop _fillin

sort cnpj_radic year niv50 
compress
save "brazrloc/data/pia-niv50", replace

rename cnpj_radic firm
drop if year<1990 | year>1998
merge firm year using "brazrloc/data/pia-data.dta"
tab _m
count if niv50==. & firm_lnlp~=.
count if niv50~=. & firm_lnlp==.

log close
cd "$home"
