version 8
set more off
set virtual on
clear
set trace off

cd "$root"

capture log close
log using "brazrloc/logs/rais-data-natl-10pct.log", replace

insheet using "rais/draws/natl10pct/wid-draw-workers-natl-10pct.csv", clear comma
order wid

duplicates drop

* RESETTING SEPARATION MONTH
replace mes_deslig = 13 if mes_deslig==0

* MAPPING OF NESTED VARIABLES (_tc for time consistency)
gen byte tipo_vinc_tc = tipo_vinc
replace tipo_vinc_tc = 1 if tipo_vinc==10
replace tipo_vinc_tc = 1 if tipo_vinc==15
replace tipo_vinc_tc = 1 if tipo_vinc==20
replace tipo_vinc_tc = 1 if tipo_vinc==25
replace tipo_vinc_tc = 2 if tipo_vinc==30
replace tipo_vinc_tc = 2 if tipo_vinc==35
replace tipo_vinc_tc = 3 if tipo_vinc==40
replace tipo_vinc_tc = 4 if tipo_vinc==50
replace tipo_vinc_tc = 4 if tipo_vinc==55
replace tipo_vinc_tc = 4 if tipo_vinc==60
replace tipo_vinc_tc = 4 if tipo_vinc==65
replace tipo_vinc_tc = 4 if tipo_vinc==70
replace tipo_vinc_tc = 4 if tipo_vinc==75
replace tipo_vinc_tc = 5 if tipo_vinc==80
replace tipo_vinc_tc = 5 if tipo_vinc==90
replace tipo_vinc_tc = 5 if tipo_vinc==95
qui count if tipo_vinc_tc > 5
if `r(N)' > 0  STOP
replace tipo_vinc=. if tipo_vinc==-1
gen byte caus_desl_tc = caus_desl
replace caus_desl_tc = 1 if caus_desl==10
replace caus_desl_tc = 2 if caus_desl==11
replace caus_desl_tc = 5 if caus_desl==12
replace caus_desl_tc = 3 if caus_desl==20
replace caus_desl_tc = 4 if caus_desl==21
replace caus_desl_tc = 6 if caus_desl==30
replace caus_desl_tc = 6 if caus_desl==31
replace caus_desl_tc = -1 if caus_desl==40
replace caus_desl_tc = 7 if caus_desl==50
replace caus_desl_tc = 8 if caus_desl==60
replace caus_desl_tc = 8 if caus_desl==62
replace caus_desl_tc = 8 if caus_desl==64
replace caus_desl_tc = 7 if caus_desl==70
replace caus_desl_tc = 7 if caus_desl==71
replace caus_desl_tc = 7 if caus_desl==72
replace caus_desl_tc = 7 if caus_desl==73
replace caus_desl_tc = 7 if caus_desl==74
replace caus_desl_tc = 7 if caus_desl==75
replace caus_desl_tc = 7 if caus_desl==76
replace caus_desl_tc = 7 if caus_desl==78
replace caus_desl_tc = 7 if caus_desl==79
replace caus_desl_tc = 9 if caus_desl==80
replace caus_desl_tc = 9 if caus_desl==90
qui count if caus_desl_tc > 9
if `r(N)' > 0  STOP
replace caus_desl=. if caus_desl==-1
replace fx_etaria = -1 if fx_etaria==. & idade== -1
replace fx_etaria = 1 if fx_etaria==. & idade>=10 & idade<=14
replace fx_etaria = 2 if fx_etaria==. & idade>=15 & idade<=17
replace fx_etaria = 3 if fx_etaria==. & idade>=18 & idade<=24
replace fx_etaria = 4 if fx_etaria==. & idade>=25 & idade<=29
replace fx_etaria = 5 if fx_etaria==. & idade>=30 & idade<=39
replace fx_etaria = 6 if fx_etaria==. & idade>=40 & idade<=49
replace fx_etaria = 7 if fx_etaria==. & idade>=50 & idade<=64
replace fx_etaria = 8 if fx_etaria==. & idade>=65
replace idade=. if idade==-1

* MAPPING OF LIKE-NESTED VARIABLES
gen byte nacionalidad_tc = nacionalidad
replace nacionalidad_tc = 21 if nacionalidad>=22 & nacionalidad<=25
replace nacionalidad_tc = 31 if nacionalidad==32 | nacionalidad==37 | nacionalidad==38
replace nacionalidad_tc = 42 if nacionalidad==43
replace nacionalidad_tc = 21 if nacionalidad==48
replace nacionalidad_tc = 42 if nacionalidad==49
replace nacionalidad_tc = 34 if nacionalidad==50
replace nacionalidad=. if nacionalidad==-1

* MAPPING OF STRINGS TO NUMERIC VARIABLES
// sector
gen byte _subs_ibge = .
replace _subs_ibge = 26 if subs_ibge=="OUTR/IGN"
replace _subs_ibge =  1 if subs_ibge=="EXTR MINERA"
replace _subs_ibge =  2 if subs_ibge=="MIN NAO MET"
replace _subs_ibge =  3 if subs_ibge=="IND METALUR"
replace _subs_ibge =  4 if subs_ibge=="IND MECANIC"
replace _subs_ibge =  5 if subs_ibge=="ELET E COMU"
replace _subs_ibge =  6 if subs_ibge=="MAT TRANSP"
replace _subs_ibge =  7 if subs_ibge=="MAD E MOBIL"
replace _subs_ibge =  8 if subs_ibge=="PAPEL E GRA"
replace _subs_ibge =  9 if subs_ibge=="BOR FUM COU"
replace _subs_ibge = 10 if subs_ibge=="IND QUIMICA"
replace _subs_ibge = 11 if subs_ibge=="IND TEXTIL"
replace _subs_ibge = 12 if subs_ibge=="IND CALCADO"
replace _subs_ibge = 13 if subs_ibge=="ALIM E BEB"
replace _subs_ibge = 14 if subs_ibge=="SER UTIL PU"
replace _subs_ibge = 15 if subs_ibge=="CONSTR CIVI"
replace _subs_ibge = 16 if subs_ibge=="COM VAREJ"
replace _subs_ibge = 17 if subs_ibge=="COM ATACAD"
replace _subs_ibge = 18 if subs_ibge=="INST FINANC"
replace _subs_ibge = 19 if subs_ibge=="ADM TEC PRO"
replace _subs_ibge = 20 if subs_ibge=="TRAN E COMU"
replace _subs_ibge = 21 if subs_ibge=="ALOJ COMUNI"
replace _subs_ibge = 22 if subs_ibge=="MED ODON VE"
replace _subs_ibge = 23 if subs_ibge=="ENSINO"
replace _subs_ibge = 24 if subs_ibge=="ADM PUBLICA"
replace _subs_ibge = 25 if subs_ibge=="AGRICULTURA"
qui count if _subs_ibge == .
if `r(N)'>0  STOP
drop subs_ibge
rename _subs_ibge subs_ibge
// occupation
sort grupo_base
merge grupo_base using "rais/cbo/grupo2cbo", nokeep
qui count if _m~=3
if `r(N)'>0  STOP  // unmatched occupation categories
drop _m grupo_base
rename cbo cbobasegrp
sort cbobasegrp
merge cbobasegrp using "rais/cbo/cbogrp2occagg", nokeep
drop _m cbobasestr
rename cbobasegrp cbogrp

* WAGE AND TENURE VARIABLE RESETTING
foreach var in rem_media rem_med__r__ rem_dezembro rem_dez__r__ temp_empr {
  replace `var' = subinstr(`var',".","",.)
  replace `var' = subinstr(`var',",",".",.)
  gen _`var' = real(`var')
  drop `var'
  rename _`var' `var'
  }

* RESET MISSING INFORMATION FOR REMAINING VARIABLES
foreach var in ano municipio identificad mes_adm mes_deslig clas_cnae_95 nat_estb nat_jurid tipo_estbl emp_em_31_12 temp_empr horas_contr tipo_vinc sit_vinculo tipo_adm caus_desl fx_etaria idade grau_instr sexo nacionalidad tipo_vinc_tc caus_desl_tc nacionalidad_tc subs_ibge cbogrp occagg {
  replace `var' = . if `var'==-1
  }
replace clas_cnae_95 = . if clas_cnae_95==0

* VARIABLE NAME LABELS
label var wid "Worker ID (running number)"
label var ano "Calendar year"
label var identificad "Plant ID (CGC/CNPJ, firm&plant)"
label var mes_adm "Month of accession"
label var mes_deslig "Month of separation"
label var rem_media "Mean monthly wage (minim. wages)"
label var rem_dezembro "December wage (minim. wages)"
label var municipio "Municipality of plant"
label var subs_ibge "Sector (IBGE, cf. 2-digit SIC)"
label var emp_em_31_12 "Indic.: Employment Dec 31"
label var tipo_vinc "Contractual status (var. def.)"
label var tipo_vinc_tc "Contractual status"
label var caus_desl "Cause of separation (var. def.)"
label var caus_desl_tc "Cause of separation"
label var cbogrp "CBO occupation (3-digit level)"
label var occagg "Aggregate Occupation"
label var grau_instr "Schooling"
label var sexo "Gender"
label var nacionalidad "Nationality (varying def.)"
label var nacionalidad_tc "Nationality"
label var temp_empr "Tenure at plant (in months)"
label var tipo_estbl "Registration status of plant"
label var tipo_adm "Type of accession"
label var fx_etaria "Employee age range"
label var idade "Employee age"
label var horas_contr "Contracted hours per week"
label var clas_cnae_95 "Sector (CNAE, like 4-digit SIC)"
label var sit_vinculo "Status of employment"
label var nat_estb "UNKNOWN VARIABLE"
label var file "SAS file in /base-pis"
* label var nat_jurid_tc "Legal form"
* label var grupo_base "CBO occupation (3-digit level)"
* label var radic_cnpj "Firm ID (CGC/CNPJ)"

* VARIABLE FORMATS AND ENGLISH VALUE LABELS
format tipo_estbl emp_em_31_12 sit_vinculo tipo_adm fx_etaria grau_instr sexo occagg %1.0f
format mes_adm mes_deslig horas_contr tipo_vinc tipo_vinc_tc caus_desl caus_desl_tc idade nacionalidad nacionalidad_tc subs_ibge nat_estb %2.0f
format cbogrp %3.0f
format temp_empr %3.1f
format ano nat_jurid %4.0f
format clas_cnae_95 %5.0f
format municipio %6.0f
format wid %7.0f 
format identificad %14.0f
label define month 0 "(not applicable)" 1 "January" 2 "February" 3 "March" 4 "April" 5 "May" 6 "June" 7 "July" 8 "August" 9 "September" 10 "October" 11 "November" 12 "December" 13 "(not applicable)"
label values mes_adm month
label values mes_deslig month
foreach pair in "sex sexo" "school grau_instr" "natvinc tipo_vinc" "causaresc caus_desl" "nation nacionalidad" "agerange fx_etaria" "tipoadm tipo_adm" "tipoest tipo_estbl" "nat_jurid nat_jurid" "natvinc tipo_vinc_tc" "causaresc caus_desl_tc" "nation nacionalidad_tc" "subs_ibge subs_ibge" "clas_cnae_95 clas_cnae_95" "cbogrp cbogrp" "occagg occagg" {
  tokenize `pair'
  local 2 = subinstr("`2'","_tc","",.)
  * rename `2' `1'
  local lblfile = substr(substr("`2'",index("`2'","_")+1,length("`2'")),1,8)
  capture qui do "rais/auxil/`lblfile'.do"
  capture qui do "rais/cnae/`lblfile'.do"
  capture qui do "rais/cbo/`lblfile'.do"
  * label values `1' `lblfile'
  label values `2' `lblfile'
  capture label values `2'_tc `lblfile'
  }
format tipo_vinc_tc %33.0f
format caus_desl_tc %32.0f

* FINALIZE
keep wid ano mes_adm mes_deslig identificad municip subs_ibge clas_cnae_95 emp_em_31_12 temp_empr cbogrp occagg tipo_vinc_tc sit_vinculo tipo_adm caus_desl_tc fx_etaria grau_instr sexo nacionalidad_tc rem_media
order wid ano mes_adm mes_deslig identificad municip subs_ibge clas_cnae_95 emp_em_31_12 temp_empr cbogrp occagg tipo_vinc_tc sit_vinculo tipo_adm caus_desl_tc fx_etaria grau_instr sexo nacionalidad_tc rem_media

sort wid ano mes_adm mes_deslig identificad municip

save "brazrloc/data/wid-draw-workers-natl-10pct", replace

keep identificad
bysort identificad: keep if _n==1
sort identificad
save "brazrloc/data/wid-draw-workers-natl-cnpj-10pct.dta", replace
* outsheet using "brazrloc/data/wid-draw-workers-natl-cnpj-10pct.csv", comma replace

log close
cd "$root"
